/*
 * A toy to remove Opera ads' banner.
 * This is public domain.
 * This code is terribly old...
 * See http://sed.free.fr/opera for latest release.
 */

#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <bfd.h>
#include <dlfcn.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <signal.h>
#include <string.h>
#include <sys/ioctl.h>
#include <stdarg.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

static int (*the_connect)(int, const struct sockaddr *, socklen_t) = 0;
static ssize_t (*the_read)(int, void *, size_t) = 0;
static ssize_t (*the_write)(int, const void *, size_t) = 0;
static int (*the_close)(int) = 0;
static int (*the_send)(int, const void *, size_t, int) = 0;
static int (*the_sendmsg)(int, const struct msghdr *, int) = 0;
static int (*the_recv)(int, void *, size_t, int) = 0;
static int (*the_recvmsg)(int, struct msghdr *, int) = 0;
static int (*the_select)(int, fd_set *, fd_set *, fd_set *, struct timeval *) = 0;
static int (*the_ioctl)(int, int, ...) = 0;
static int (*the_socket)(int, int, int) = 0;
static pid_t (*the_fork)(void) = 0;
int  (*the_execve)(const char *, char *const [], char *const[]) = 0;
static int (*the_open)(const char *, int, ...) = 0;

static int saved_socket = -1;
static char saved_buffer[] =
"HTTP/1.1 200 OK
Content-Length: 597
Connection: close
Content-Type: text/html

<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\">
<head>
<title>Opera anti-text ads</title>
<meta http-equiv=\"content-type\" content=\"text/html; charset=UTF-8\" />
<style type=\"text/css\" media=\"all\">
body { background:white; font-size:12px;
        font-family:arial; line-height:14px; height:28px; overflow:hidden;
        margin:0; padding:0; }
p { margin:2px; text-align: center; } 
</style>
</head>
<body>
<p>Free as in <a href=\"http://sed.free.fr\">\"Freezer\"</a>.
</body>
</html>";
static int sent = 0;

#if 0
#define toto fprintf
#else
static void toto(FILE *f, ...)
{
}
#endif

/* some local declarations */
static void emergency_exit(int);

/* our static globals */
struct trace {
  void *address;
  size_t address_size;
  int size;
  int max_size;
  void **bt;
};

static unsigned int lib_init=0;

#define NB_SOCKETS 256
//static int sockets[NB_SOCKETS];
//static int wrapper[NB_SOCKETS];
//static int rsockets[NB_SOCKETS];
//static int rwrapper[NB_SOCKETS];

static void init_lib(void)
{
  char *libc_path;
  void *p;
  //int i;

  //for (i=0; i<NB_SOCKETS; i++)
  //  sockets[i] = 0;

  /* useless check, but good practice */
  if (lib_init)
    return;

  lib_init = 1;

  libc_path = getenv("LIBC_PATH");
  if (!libc_path) {
    toto(stderr, "error : LIBC_PATH environment variable not declared\n");
    emergency_exit(1);
  }

  /* let's interface with the libc */
  p = dlopen(libc_path, RTLD_LAZY);
  if (!p) {
    toto(stderr, "dlopen error. You surely gave a wrong LIBC_PATH\n");
    emergency_exit(1);
  }

  the_connect = dlsym(p, "connect");
  if (!the_connect) {
    perror("dlsym(connect) error");
    exit(1);
  }

  the_read = dlsym(p, "read");
  if (!the_read) {
    perror("dlsym(read) error");
    exit(1);
  }

  the_write = dlsym(p, "write");
  if (!the_write) {
    perror("dlsym(write) error");
    exit(1);
  }

  the_close = dlsym(p, "close");
  if (!the_close) {
    perror("dlsym(close) error");
    exit(1);
  }

  the_send = dlsym(p, "send");
  if (!the_send) {
    perror("dlsym(send) error");
    exit(1);
  }

  the_sendmsg = dlsym(p, "sendmsg");
  if (!the_sendmsg) {
    perror("dlsym(sendmsg) error");
    exit(1);
  }

  the_recv = dlsym(p, "recv");
  if (!the_recv) {
    perror("dlsym(recv) error");
    exit(1);
  }

  the_recvmsg = dlsym(p, "recvmsg");
  if (!the_recvmsg) {
    perror("dlsym(recvmsg) error");
    exit(1);
  }

  the_select = dlsym(p, "select");
  if (!the_select) {
    perror("dlsym(select) error");
    exit(1);
  }

  the_ioctl = dlsym(p, "ioctl");
  if (!the_ioctl) {
    perror("dlsym(ioctl) error");
    exit(1);
  }

  the_socket = dlsym(p, "socket");
  if (!the_socket) {
    perror("dlsym(socket) error");
    exit(1);
  }

  the_fork = dlsym(p, "fork");
  if (!the_fork) {
    perror("dlsym(fork) error");
    exit(1);
  }

  the_execve = dlsym(p, "execve");
  if (!the_execve) {
    perror("dlsym(execve) error");
    exit(1);
  }

  the_open = dlsym(p, "open");
  if (!the_open) {
    perror("dlsym(connect) error");
    exit(1);
  }
}

int execve (const char *filename, char *const argv [], char *const envp[])
{
  int i=0;
  if (!the_execve)
    init_lib();
  if (!the_execve) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  toto(stderr, "\nexecve %s\n", filename);
  while (envp[i]) {if (!strncmp(envp[i], "LD_PRELOAD", 10)) toto(stderr, "%s\n", envp[i]); i++;}
  return the_execve(filename, argv, envp);
}

#if 0
pid_t fork(void)
{
  int ret;
  int no;

  if (!the_fork)
    init_lib();
  if (!the_fork) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  toto(stderr, "fork\n");
  ret = the_fork();
  no =errno;
  if (ret) toto(stderr, "\nforked => %d\n\n", ret);
  errno = no;
  return ret;
}
#endif

static int wrap_me(int sockfd, const struct sockaddr *s, socklen_t l)
{
  int oflg = fcntl(sockfd, F_GETFL);
  struct hostent *to;
  int tno;
  struct sockaddr_in addr;

  to = gethostbyname("bop");
//  to = gethostbyname("bugdeluxe");
//  to = gethostbyname("jinx");
//  to = gethostbyname("pouf");
  if (!to) {
    perror("gethostbyname");
    return -1;
  }

  addr.sin_family=AF_INET;
  addr.sin_addr.s_addr=((struct in_addr *)(to->h_addr))->s_addr;
  addr.sin_port=htons(4666);

  fcntl(sockfd, F_SETFL, oflg & ~O_NONBLOCK);

#if 0
  ret = -1;

  while (ret == -1) {
    if ((ret=the_connect(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in)))== -1) {
      int tno = errno;
      toto(stderr, "there was a problem ! %s %d %d\n", strerror(errno), errno, EINPROGRESS);
      if (tno != EINPROGRESS && tno != EALREADY) {
        errno = tno;
        return ret;
      }
    }
  }

  errno = 0;
#endif

    if (the_connect(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_in))== -1) {
      tno = errno;
      goto error;
    }

  if (write(sockfd, &l, sizeof(socklen_t)) != sizeof(socklen_t) || write(sockfd, s, l) != l) {
    tno = errno;
    perror("write");
    goto error;
  }

  fcntl(sockfd, F_SETFL, oflg);
  return 0;

error:
  fcntl(sockfd, F_SETFL, oflg);
  errno = tno;
  return -1;
}

int connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen)
{
  if (!the_connect)
    init_lib();
  if (!the_connect) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  toto(stderr, "connect (addrlen = %d (%d)) socket=%d\n", addrlen, sizeof(struct sockaddr_in), sockfd);
  if (addrlen != sizeof(struct sockaddr_in))
    return the_connect(sockfd, serv_addr, addrlen);

  if (serv_addr->sa_family != AF_INET)
    return the_connect(sockfd, serv_addr, addrlen);
{int i; for (i=0; i<addrlen; i++) toto(stderr, "%d ", *((unsigned char *)serv_addr + i)); toto(stderr, "\n");}
{
  unsigned char *z=(unsigned char *)serv_addr;
  z+=4;
  toto(stderr, "%d.%d.%d.%d\n", z[0], z[1], z[2], z[3]);
if (z[0] == 193 && z[1] == 69 && z[2] == 116 && z[3] == 13) {
  saved_socket = sockfd;
  return 0;
  //return the_connect(sockfd, serv_addr, addrlen);
}
}
return the_connect(sockfd, serv_addr, addrlen);

  {
    unsigned char *z=(unsigned char *)serv_addr;
    z+=4;
    if (addrlen>=8 && z[0] == 127 && z[1] == 0 && z[2]==0 && z[3]==1) {
      toto(stderr, "local connection, don't wrap it\n");
      return the_connect(sockfd, serv_addr, addrlen);
    }
  }

{int i; for (i=0; i<addrlen; i++) toto(stderr, "%d ", *((unsigned char *)serv_addr + i)); toto(stderr, "\n");}

  return wrap_me(sockfd, serv_addr, addrlen);
}

int socket(int domain, int type, int protocol)
{
  int ret;

  if (!the_socket)
    init_lib();
  if (!the_socket) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  toto(stderr, "socket %d %d %d\n", domain, type, protocol);
  if (domain == PF_INET) toto(stderr, "PF_INET\n"); else toto(stderr, "not PF_INET (%d)\n", domain);
  if (type == SOCK_STREAM) toto(stderr, "SOCK_STREAM\n"); else toto(stderr, "not SOCK_STREAM (%d)\n", type);
  if (type == SOCK_DGRAM) toto(stderr, "SOCK_DGRAM\n");
  if (protocol == IPPROTO_TCP) toto(stderr, "IPPROTO_TCP\n"); else toto(stderr, "not IPPROTO_TCP (%d)\n", protocol);

  ret = the_socket(domain, type, protocol);

  toto(stderr, "socket returned %d\n", ret);

  return ret;
}

#if 0
ssize_t do_read(int fd, void *buf, size_t count)
{
  toto(stderr, "do_read\n");
  return read(wrapper[fd], buf, count);
}

ssize_t do_write(int fd, const void *buf, size_t count)
{
  toto(stderr, "do_write\n");
  return write(wrapper[fd], buf, count);
}
#endif

ssize_t read(int fd, void *buf, size_t count)
{
  int ret;
  int i;
  if (!the_read)
    init_lib();
  if (!the_read) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  //if (sockets[fd] == 1)
  //  return do_read(fd, buf, count);

  ret = the_read(fd, buf, count);
  if (fd == saved_socket) {
    if (ret > 0) for (i=0; i<ret; i++) toto(stderr, "%c", ((char *)buf)[i]);
    toto(stderr, "\n");
  }
  return ret;
}

ssize_t write(int fd, const void *buf, size_t count)
{
  int ret;
  int i;
  if (!the_write)
    init_lib();
  if (!the_write) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }

  //if (sockets[fd] == 1)
  //  return do_write(fd, buf, count);

  ret = the_write(fd, buf, count);
  if (fd == saved_socket) {
    if (ret > 0) for (i=0; i<ret; i++) toto(stderr, "%c", ((char*)buf)[i]);
    toto(stderr, "\n");
  }
  return ret;
}

int close(int fd)
{
  if (!the_close)
    init_lib();
  if (!the_close) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  if (fd == saved_socket) {
    saved_socket = -1;
    sent = 0;
  }
#if 0
  if (sockets[fd]) {
    toto(stderr, "closing a socket %d\n", fd);
    sockets[fd] = 0;
    rsockets[wrapper[fd]] = 0;
  }
#endif
  return the_close(fd);
}

int open(const char *t, int z, ...)
{
  va_list zz;
  mode_t r;
  int ret;

  if (!the_open)
    init_lib();
  if (!the_open) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
//fprintf(stderr, "open %s\n", t);
  va_start(zz, z);
  r = va_arg(zz, mode_t);
#if 0
  if (!strcmp(t, "/dev/dsp")) {
    fprintf(stderr, "opening /dev/dsp1 instead of /dev/dsp\n");
    ret = the_open("/dev/dsp1", z, r);
  } else
#endif
    ret = the_open(t, z, r);
  va_end(zz);
  return ret;
}

int send(int s, const void *msg, size_t len, int flags)
{
  int i;

  if (!the_send)
    init_lib();
  if (!the_send) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  toto(stderr, "send\n");

  //if (sockets[s] == 1)
  //  return the_send(wrapper[s], msg, len, flags);

  if (s == saved_socket) {
    return len;
    for (i=0; i<len; i++) toto(stderr, "%c", ((char*)msg)[i]);
    toto(stderr, "\n");
  }
  return the_send(s, msg, len, flags);
}

int sendmsg(int s, const struct msghdr *msg, int flags)
{
  if (!the_sendmsg)
    init_lib();
  if (!the_sendmsg) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  toto(stderr, "sendmsg\n");

  //if (sockets[s] == 1)
  //  return the_sendmsg(wrapper[s], msg, flags);

  return the_sendmsg(s, msg, flags);
}

int recv(int s, void *buf, size_t len, int flags)
{
  int ret;
  int i;
  if (!the_recv)
    init_lib();
  if (!the_recv) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  toto(stderr, "recv\n");

  if (s == saved_socket) {
toto(stderr, "zpoozizoozi = %d\n", sizeof(saved_buffer));
    int nl;
    toto(stderr, "buffer of size %d\n", len);
    /* don't ask me why Opera does a weird stuff there, I have to
     * return 1 byte if requested length is 1, and this byte has to be 'H'
     */
    if (len == 1) { ((char*)buf)[0] = 'H'; return 1; }
    nl = len;
    if (nl > sizeof(saved_buffer) - sent) nl = sizeof(saved_buffer) - sent;
    memcpy(buf, saved_buffer + sent, nl);
    ret = nl;
    sent += ret;
    toto(stderr, "ret = %d\n", ret);
    return ret;
  }

  //if (sockets[s] == 1)
  //  return the_recv(wrapper[s], buf, len, flags);

  ret = the_recv(s, buf, len, flags);
  if (s == saved_socket) {
    if (ret>0) for (i=0; i<ret; i++) toto(stderr, "%c", ((char*)buf)[i]);
    toto(stderr, "\n");
  }
  return ret;
}

int recvmsg(int s, struct msghdr *msg, int flags)
{
  if (!the_recvmsg)
    init_lib();
  if (!the_recvmsg) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  toto(stderr, "recvmsg\n");

  //if (sockets[s] == 1)
  //  return the_recvmsg(wrapper[s], msg, flags);

  return the_recvmsg(s, msg, flags);
}

int select(int n, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, struct timeval *timeout)
{
  //int i;
  //int ret;
  //fd_set mr, mw, me;
  //fd_set *pr, *pw, *pe;

  if (!the_select)
    init_lib();
  if (!the_select) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  //toto(stderr, "select\n");

  if (saved_socket == -1 || !FD_ISSET(saved_socket, readfds))
    return the_select(n, readfds, writefds, exceptfds, timeout);

  if (sent < sizeof(saved_buffer)) {
    FD_ZERO(readfds);
    FD_ZERO(writefds);
    FD_ZERO(exceptfds);
    FD_SET(saved_socket, readfds);
    return 1;
  } else FD_CLR(saved_socket, readfds);

  return the_select(n, readfds, writefds, exceptfds, timeout);

#if 0
  /* read */
  FD_ZERO(&mr);
  if (readfds)
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, readfds))
      continue;
    if (sockets[i])
      FD_SET(wrapper[i], &mr);
    else
      FD_SET(i, &mr);
  }

  /* write */
  FD_ZERO(&mw);
  if (writefds)
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, writefds))
      continue;
    if (sockets[i])
      FD_SET(wrapper[i], &mw);
    else
      FD_SET(i, &mw);
  }

  /* except */
  FD_ZERO(&me);
  if (exceptfds)
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, exceptfds))
      continue;
    if (sockets[i])
      FD_SET(wrapper[i], &me);
    else
      FD_SET(i, &me);
  }

  pr = readfds ? &mr : 0;
  pw = writefds ? &mw : 0;
  pe = exceptfds ? &me : 0;
  ret = the_select(n, pr, pw, pe, timeout);

  /* read */
  if (readfds) {
  FD_ZERO(readfds);
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, &mr))
      continue;
    if (rsockets[i])
      FD_SET(rwrapper[i], readfds);
    else
      FD_SET(i, readfds);
  }
  }

  /* write */
  if (writefds) {
  FD_ZERO(writefds);
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, &mw))
      continue;
    if (rsockets[i])
      FD_SET(rwrapper[i], writefds);
    else
      FD_SET(i, writefds);
  }
  }

  /* except */
  if (exceptfds) {
  FD_ZERO(exceptfds);
  for (i=0; i<NB_SOCKETS; i++) {
    if (!FD_ISSET(i, &me))
      continue;
    if (rsockets[i])
      FD_SET(rwrapper[i], exceptfds);
    else
      FD_SET(i, exceptfds);
  }
  }

  return ret;
#endif
}

#if 0
int ioctl(int d, unsigned long request, ...)
{
  va_list ap;
  void *r;
  if (!the_ioctl)
    init_lib();
  if (!the_ioctl) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  va_start(ap, request);
  r = va_arg(ap, void *);
  va_end(ap);

  if (sockets[d] == 1) {
    toto(stderr, "ioctl on %d\n", d);
    d = wrapper[d];
  }

  return the_ioctl(d, request, r);
}
#endif

#if 0
int open(const char *t, int z, mode_t r)
{
  toto(stderr, "open %s\n", t);
  if (!the_open)
    init_lib();
  if (!the_open) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  if (!strcmp(t, "/dev/mixer")) {
    int fd = the_open("/tmp/sed.pipo.mixer", O_RDWR|O_CREAT|O_TRUNC, 0777);
    toto(stderr, "catching up mixer %d\n", fd);
    return fd;
  }
  if (!strcmp(t, "/dev/dsp")) {
    int fd = the_open("/tmp/sed.pipo", O_RDWR|O_CREAT|O_TRUNC, 0777);
    toto(stderr, "/dev/dsp detected -> opening /tmp/sed.pipo %d %d-> %d\n", z, r, fd);
    snd = fd;
    return fd;
  }
  return the_open(t, z, r);
}

typedef struct audio_buf_info {
   int fragments; 
int fragstotal; /* Total # of fragments allocated */
int fragsize;   /* Size of a fragment in bytes */
int bytes;   /* Available space in bytes (includes partially used fragments) */
/* Note! 'bytes' could be more than fragments*fragsize */
} audio_buf_info;

int ioctl(int d, unsigned long request, ...)
{
  va_list ap;
  void *r;
  if (!the_ioctl)
    init_lib();
  if (!the_ioctl) {
    toto(stderr, "problem with preload stuff\n");
    return -1;
  }
  va_start(ap, request);
  r = va_arg(ap, void *);
  va_end(ap);
  if (d == snd && snd != -1) {
    char c = ((unsigned)request >>8) & 0xff;
    int w = (unsigned)request & 0xff;

    if (c == 'P' && w == 0) {
      //toto(stderr, "reset card\n");
    } else
    if (c == 'P' && w == 2) {
      toto(stderr, "set speed at %d\n", *(int *)r);
    } else
    if (c == 'P' && w == 6) {
      toto(stderr, "set nb channels %d\n", *(int *)r);
    } else
    if (c == 'P' && w == 5) {
      toto(stderr, "set format %d\n", *(int *)r);
    } else
    if (c == 'P' && w == 10) {
      //toto(stderr, "set nb fragments %8.8x\n", *(int *)r);
    } else
    if (c == 'P' && w == 12) {
      audio_buf_info *x = r;
      //toto(stderr, "asking for space ? ok, there we go :)\n");
      x->fragments = 10;
      x->fragstotal = 10;
      x->fragsize = 4096;
      x->bytes = 10 * 4096;
    } else
    if (c == 'P' && w == 23) {
      //toto(stderr, "getodelay %8.8x\n", *(int *)r);
      *(int *)r = 0000;
    } else {
      toto(stderr, "unkown ioctl\n");
      toto(stderr, "calling ioctl on %d request=%8.8x\n", d, (unsigned)request);
      toto(stderr, "%c %d\n", ((unsigned)request >>8) & 0xff, (unsigned)request & 0xff);
      return -1;
    }
    return 0;
  }
  return the_ioctl(d, request, r);
}
#endif

static void emergency_exit(int status)
{
  kill(getpid(), SIGTERM);
}
